﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace Customercollection.ViewModel
{
   public class Commandclass:ICommand
    {
       public Action<object> _action;
       public Predicate<object> _predicate;

       public Commandclass(Predicate<object> predicate,Action<object> action)
       {
           _action = action;
           _predicate = predicate;
       }
        public bool CanExecute(object parameter)
        {
            if (_predicate != null)
            {
                return _predicate(parameter);
            }
            else
            {
                return true;
            }
            
            //throw new NotImplementedException();
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            if (_action != null)
            {
               _action(parameter);
                            
            }
            //throw new NotImplementedException();
        }


       public void raiseEvent()
        {
           if(CanExecuteChanged!=null)
           {
               this.CanExecuteChanged(this, EventArgs.Empty);
           }
        }
    }
}
